CodeForces - 931E Game with String (思维)


Game with String
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Vasya and Kolya play a game with a string, using the following rules. Initially, Kolya creates a string s, consisting of small English letters, and uniformly at random chooses an integer k from a segment [0, len(s) - 1]. He tells Vasya this string s, and then shifts it k letters to the left, i. e. creates a new string t = sk + 1sk + 2... sns1s2... sk. Vasya does not know the integer k nor the string t, but he wants to guess the integer k. To do this, he asks Kolya to tell him the first letter of the new string, and then, after he sees it, open one more letter on some position, which Vasya can choose.

Vasya understands, that he can't guarantee that he will win, but he wants to know the probability of winning, if he plays optimally. He wants you to compute this probability.

Note that Vasya wants to know the value of k uniquely, it means, that if there are at least two cyclic shifts of s that fit the information Vasya knowns, Vasya loses. Of course, at any moment of the game Vasya wants to maximize the probability of his win.

Input

The only string contains the string s of length l (3 ≤ l ≤ 5000), consisting of small English letters only.

Output

Print the only number — the answer for the problem. You answer is considered correct, if its absolute or relative error does not exceed 10 - 6.

Formally, let your answer be a, and the jury's answer be b. Your answer is considered correct if 

Examples
input
Copy
technocup
output
1.000000000000000
input
Copy
tictictactac
output
0.333333333333333
input
Copy
bbaabaabbb
output
0.100000000000000
Note

In the first example Vasya can always open the second letter after opening the first letter, and the cyclic shift is always determined uniquely.

In the second example if the first opened letter of t is "t" or "c", then Vasya can't guess the shift by opening only one other letter. On the other hand, if the first letter is "i" or "a", then he can open the fourth letter and determine the shift uniquely.



题意:没看懂。

解题思路:看了别人的博客终于搞懂了题意。首先要注意几点

1.问的是最大胜率,就是最后猜K猜的对不对!而不是猜字母。

2.K有strlen(str)种情况!

3.所以胜率就是,猜每种距离的胜率之和。

4.所以无论第一个字母是啥,第二个字母是啥,我只关心你猜的K对不对。

5.Kolya是可以作弊的!只要你不能唯一的确定这个字符串,那么你必输!


所以第二个样例的0.333333是这样来的

tictictactac

一共有4种字母,12种K

假设第一个字母是t,你的胜率为0

假设第一个字母是i,那么要使概率最大,你必须挑第四个或第七字母,你的胜率才能为1,这里占了两种K

假设第一个字母是c,那么你的胜率为0

假设第一个字母是a,情况跟i一样。

那么最后的胜率就是  4/12=0.333333333333333


算法:https://blog.csdn.net/qq_29556211/article/details/79524639


#include <bits/stdc++.h>
using namespace std;

int cnt[26][26][5000 + 5];

int main()
{
    string str;
    cin >> str;
    for(int i = 0; i < str.size(); i++)
    {
        for(int len = 1; len < str.size(); len++)
        {
            cnt[str[i] - 'a'][str[(i + len) % str.size()] - 'a'][len]++;
        }
    }

    double ans = 0;
    for(int i = 0; i < 26; i++)
    {
        int mx = 0;
        for(int len = 1; len < str.size(); len++)
        {
            int temp = 0;
            for(int j = 0; j < 26; j++)
            {
                if(cnt[i][j][len] == 1)   
				 temp++;
            }
            mx = max(mx, temp);
        }
		//cout<<mx<<endl;
        ans += 1.0 * mx / str.size();
    }
    printf("%.8f\n", ans);

    return 0;
}








CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值